'''
NUMBER  ->   <число>
group   ->   "("  add  ")"
           | NUMBER
mult    ->   group  ( ( "*" | "/" )  group )*
add     ->   mult   ( ( "+" | "-" )  mult  )*
result  ->   add
'''

class Parser:
    def __init__(self, expr: str):
        self.expr = expr
        self.pos = 0

    @property
    def curr(self) -> str:
        if self.pos < len(self.expr):
            return self.expr[self.pos]
        else:
            return '$'

    def NUMBER(self) -> float:
        tmp = ''
        while self.curr.isdigit() or self.curr == '.':
            tmp += self.curr
            self.pos += 1
        return float(tmp)

    def group(self) -> float:
        if self.curr == '(':
            self.pos += 1
            res = self.add()
            self.pos += 1
        else:
            res = self.NUMBER()
        return res

    def mult(self) -> float:
        res = self.group()
        while self.curr in ('*', '/'):
            op = self.curr
            self.pos += 1
            tmp = self.group()
            res = res * tmp if op == '*' else res / tmp
        return res

    def add(self) -> float:
        res = self.mult()
        while self.curr in ('+', '-'):
            op = self.curr
            self.pos += 1
            tmp = self.mult()
            res = res + tmp if op == '+' else res - tmp
        return res

    def start(self) -> float:
        res = self.add()
        if self.pos != len(self.expr):
            raise Exception('not end of expr')
        return res


expr = '3+2*(5+2-2*(1+1.054))'
p = Parser(expr)
res = p.start()
print(res)
